﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Pic.DAL.SqlServer
{
    public class NodeTag
    {
        #region Enum
        public enum NodeType
        {
            NT_BRANCH
            , NT_DOCUMENT
        }
        #endregion

        #region Data members
        private NodeType _type;
        private int _id;
        #endregion

        #region Constructors
        public NodeTag(NodeType type, int id)
        {
            _type = type; _id = id;
        }

        public NodeTag(string value)
        {
            string[] sSplit = value.Split(' ');
            _type = sSplit[0] == "BRANCH" ? NodeType.NT_BRANCH : NodeType.NT_DOCUMENT;
            _id = Convert.ToInt32(sSplit[1]);
        }
        #endregion

        #region Object overrides
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            if (_type == NodeType.NT_BRANCH)
                sb.Append("BRANCH");
            else if (_type == NodeType.NT_DOCUMENT)
                sb.Append("DOCUMENT");
            sb.Append(' ');
            sb.Append(_id);
            return sb.ToString();
        }
        #endregion

        #region Public Properties
        public int Id { get { return _id; } }
        public bool IsBranch { get { return NodeType.NT_BRANCH == _type; } }
        public bool IsDocument { get { return NodeType.NT_DOCUMENT == _type; } }
        #endregion
    }
}
