﻿#region Using directives
using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.Caching;
using System.Web.SessionState;
using Pic.Plugin;
#endregion

namespace Pic.Param.HttpHandler
{
    class FileHttpHandler : IHttpHandler
    {
        public void ProcessRequest(HttpContext context)
        {
            //
            // invoke webservice to obtain dxf file
            //
            Pic.Param.WebService.ParamService picParamServ = new Pic.Param.WebService.ParamService();

            string sFileFormat = "pdf";

            string sName = context.Request.QueryString["name"];
            ParameterStack stack = picParamServ.GetParameters(sName);

            // retrieve parameter values from url
            foreach (Parameter param in stack.ParameterList)
            {
                if (param.GetType().ToString().Equals("Pic.Plugin.ParameterDouble"))
                {
                    ParameterDouble paramDouble = (ParameterDouble)param;
                    paramDouble.Value = double.Parse(context.Request.QueryString[param.Name]);
                }
                else if (param.GetType() == typeof(ParameterBool))
                {
                    ParameterBool paramBool = param as ParameterBool;
                    paramBool.Value = bool.Parse(context.Request.QueryString[param.Name]);
                }
            }
            // get file
            System.Byte[] fileModel = picParamServ.GetExportFile(sFileFormat, sName, stack);
            // write file as response
            context.Response.ClearContent();
            context.Response.ClearHeaders();
            if ("dxf" == sFileFormat)
            {
                context.Response.AddHeader("content-disposition", string.Format("inline; filename={0}.dxf", sName));
            }
            else if ("pdf" == sFileFormat)
            { 
                context.Response.AddHeader("content-length", fileModel.GetLength(0).ToString());
            }
            context.Response.ContentType = "application/" + sFileFormat;
            context.Response.BinaryWrite(fileModel);
            context.Response.Flush();
            context.Response.Close();
        }

        public bool IsReusable
        {
            get
            {
                return true;
            }
        }
    }
}
