﻿#region Using directives
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using Pic.DAL.SqlServer;
#endregion

namespace Pic.Param.WebGallery
{
    /// <summary>
    /// ThumbFromID inherits from <see System.Web.UI.Page>System.Web.UI.Page</see>
    /// Retrieves a binary array from the SQL Server database.
    /// Once this binary array is retrieved from the database, it is written to a memory stream
    /// which is then written to the standard Html Response stream, this binary data represents
    /// an image from the database
    /// </summary>
    public partial class ThumbFromID : System.Web.UI.Page
    {
        #region Instance fields
        // constants used to create URLs to this page
        public const string PAGENAME = "ThumbFromID.aspx";
        // the image primary key for use when getting image data from database
        public const string NODEID = "node_id";
        #endregion

        #region Private methods
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                try
                {
                    // get the Id of the DocumentTreeNode to retrieve from database
                    int nodeId = Convert.ToInt32(Request.QueryString[NODEID]);
                    // get the document tree node
                    PPDataContext db = new PPDataContext();
                    Pic.DAL.SqlServer.TreeNode node = Pic.DAL.SqlServer.TreeNode.GetById(db, nodeId);
                    // get the thumbnail and save to Response stream
                    using (System.Drawing.Image image = node.Thumbnail.GetImage())
                        image.Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message, ex);
                }
            }
        }
        #endregion
    }
}
